"use strict";
// tslint:disable no-console
Object.defineProperty(exports, "__esModule", { value: true });
const clean = require("clean-stack");
const config_1 = require("./config");
exports.handle = (err) => {
    try {
        if (!err)
            err = new Error('no error?');
        let stack = clean(err.stack, { pretty: true });
        let message = stack;
        if (err.lyndon && typeof err.render === 'function')
            message = err.render();
        if (message)
            console.error(message);
        process.exitCode = (err.lyndon && err.lyndon.exit !== undefined) ? err.lyndon.exit : 1;
        if (config_1.config.errorLogger && err.code !== 'EEXIT') {
            config_1.config.errorLogger.log(stack);
            config_1.config.errorLogger.flush()
                .catch(console.error);
        }
    }
    catch (e) {
        console.error(err.stack);
        console.error(e.stack);
    }
};
